package bdledger.api.grpc.query;

import static io.grpc.MethodDescriptor.generateFullMethodName;
import static io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static io.grpc.stub.ClientCalls.asyncUnaryCall;
import static io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static io.grpc.stub.ClientCalls.blockingUnaryCall;
import static io.grpc.stub.ClientCalls.futureUnaryCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.27.0)",
    comments = "Source: bdledger/api/query.proto")
public final class QueryGrpc {

  private QueryGrpc() {}

  public static final String SERVICE_NAME = "bdledger.api.Query";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<bdledger.api.grpc.query.GetBlockByHashRequest,
      bdledger.api.grpc.query.GetBlockByHashResponse> getGetBlockByHashMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetBlockByHash",
      requestType = bdledger.api.grpc.query.GetBlockByHashRequest.class,
      responseType = bdledger.api.grpc.query.GetBlockByHashResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdledger.api.grpc.query.GetBlockByHashRequest,
      bdledger.api.grpc.query.GetBlockByHashResponse> getGetBlockByHashMethod() {
    io.grpc.MethodDescriptor<bdledger.api.grpc.query.GetBlockByHashRequest, bdledger.api.grpc.query.GetBlockByHashResponse> getGetBlockByHashMethod;
    if ((getGetBlockByHashMethod = QueryGrpc.getGetBlockByHashMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getGetBlockByHashMethod = QueryGrpc.getGetBlockByHashMethod) == null) {
          QueryGrpc.getGetBlockByHashMethod = getGetBlockByHashMethod =
              io.grpc.MethodDescriptor.<bdledger.api.grpc.query.GetBlockByHashRequest, bdledger.api.grpc.query.GetBlockByHashResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetBlockByHash"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.GetBlockByHashRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.GetBlockByHashResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("GetBlockByHash"))
              .build();
        }
      }
    }
    return getGetBlockByHashMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdledger.api.grpc.query.BlocksRequest,
      bdledger.api.grpc.query.GetBlocksResponse> getGetBlocksMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetBlocks",
      requestType = bdledger.api.grpc.query.BlocksRequest.class,
      responseType = bdledger.api.grpc.query.GetBlocksResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdledger.api.grpc.query.BlocksRequest,
      bdledger.api.grpc.query.GetBlocksResponse> getGetBlocksMethod() {
    io.grpc.MethodDescriptor<bdledger.api.grpc.query.BlocksRequest, bdledger.api.grpc.query.GetBlocksResponse> getGetBlocksMethod;
    if ((getGetBlocksMethod = QueryGrpc.getGetBlocksMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getGetBlocksMethod = QueryGrpc.getGetBlocksMethod) == null) {
          QueryGrpc.getGetBlocksMethod = getGetBlocksMethod =
              io.grpc.MethodDescriptor.<bdledger.api.grpc.query.BlocksRequest, bdledger.api.grpc.query.GetBlocksResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetBlocks"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.BlocksRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.GetBlocksResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("GetBlocks"))
              .build();
        }
      }
    }
    return getGetBlocksMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdledger.api.grpc.query.BlocksRequest,
      bdledger.api.grpc.query.CountBlocksResponse> getCountBlocksMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "CountBlocks",
      requestType = bdledger.api.grpc.query.BlocksRequest.class,
      responseType = bdledger.api.grpc.query.CountBlocksResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdledger.api.grpc.query.BlocksRequest,
      bdledger.api.grpc.query.CountBlocksResponse> getCountBlocksMethod() {
    io.grpc.MethodDescriptor<bdledger.api.grpc.query.BlocksRequest, bdledger.api.grpc.query.CountBlocksResponse> getCountBlocksMethod;
    if ((getCountBlocksMethod = QueryGrpc.getCountBlocksMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getCountBlocksMethod = QueryGrpc.getCountBlocksMethod) == null) {
          QueryGrpc.getCountBlocksMethod = getCountBlocksMethod =
              io.grpc.MethodDescriptor.<bdledger.api.grpc.query.BlocksRequest, bdledger.api.grpc.query.CountBlocksResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "CountBlocks"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.BlocksRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.CountBlocksResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("CountBlocks"))
              .build();
        }
      }
    }
    return getCountBlocksMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdledger.api.grpc.query.GetTransactionByHashRequest,
      bdledger.api.grpc.query.GetTransactionByHashResponse> getGetTransactionByHashMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetTransactionByHash",
      requestType = bdledger.api.grpc.query.GetTransactionByHashRequest.class,
      responseType = bdledger.api.grpc.query.GetTransactionByHashResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdledger.api.grpc.query.GetTransactionByHashRequest,
      bdledger.api.grpc.query.GetTransactionByHashResponse> getGetTransactionByHashMethod() {
    io.grpc.MethodDescriptor<bdledger.api.grpc.query.GetTransactionByHashRequest, bdledger.api.grpc.query.GetTransactionByHashResponse> getGetTransactionByHashMethod;
    if ((getGetTransactionByHashMethod = QueryGrpc.getGetTransactionByHashMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getGetTransactionByHashMethod = QueryGrpc.getGetTransactionByHashMethod) == null) {
          QueryGrpc.getGetTransactionByHashMethod = getGetTransactionByHashMethod =
              io.grpc.MethodDescriptor.<bdledger.api.grpc.query.GetTransactionByHashRequest, bdledger.api.grpc.query.GetTransactionByHashResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetTransactionByHash"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.GetTransactionByHashRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.GetTransactionByHashResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("GetTransactionByHash"))
              .build();
        }
      }
    }
    return getGetTransactionByHashMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexRequest,
      bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexResponse> getGetTransactionByBlockHashAndIndexMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetTransactionByBlockHashAndIndex",
      requestType = bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexRequest.class,
      responseType = bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexRequest,
      bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexResponse> getGetTransactionByBlockHashAndIndexMethod() {
    io.grpc.MethodDescriptor<bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexRequest, bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexResponse> getGetTransactionByBlockHashAndIndexMethod;
    if ((getGetTransactionByBlockHashAndIndexMethod = QueryGrpc.getGetTransactionByBlockHashAndIndexMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getGetTransactionByBlockHashAndIndexMethod = QueryGrpc.getGetTransactionByBlockHashAndIndexMethod) == null) {
          QueryGrpc.getGetTransactionByBlockHashAndIndexMethod = getGetTransactionByBlockHashAndIndexMethod =
              io.grpc.MethodDescriptor.<bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexRequest, bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetTransactionByBlockHashAndIndex"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("GetTransactionByBlockHashAndIndex"))
              .build();
        }
      }
    }
    return getGetTransactionByBlockHashAndIndexMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdledger.api.grpc.query.TransactionsRequest,
      bdledger.api.grpc.query.GetTransactionsResponse> getGetTransactionsMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetTransactions",
      requestType = bdledger.api.grpc.query.TransactionsRequest.class,
      responseType = bdledger.api.grpc.query.GetTransactionsResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdledger.api.grpc.query.TransactionsRequest,
      bdledger.api.grpc.query.GetTransactionsResponse> getGetTransactionsMethod() {
    io.grpc.MethodDescriptor<bdledger.api.grpc.query.TransactionsRequest, bdledger.api.grpc.query.GetTransactionsResponse> getGetTransactionsMethod;
    if ((getGetTransactionsMethod = QueryGrpc.getGetTransactionsMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getGetTransactionsMethod = QueryGrpc.getGetTransactionsMethod) == null) {
          QueryGrpc.getGetTransactionsMethod = getGetTransactionsMethod =
              io.grpc.MethodDescriptor.<bdledger.api.grpc.query.TransactionsRequest, bdledger.api.grpc.query.GetTransactionsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetTransactions"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.TransactionsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.GetTransactionsResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("GetTransactions"))
              .build();
        }
      }
    }
    return getGetTransactionsMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdledger.api.grpc.query.TransactionsRequest,
      bdledger.api.grpc.query.CountTransactionsResponse> getCountTransactionsMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "CountTransactions",
      requestType = bdledger.api.grpc.query.TransactionsRequest.class,
      responseType = bdledger.api.grpc.query.CountTransactionsResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdledger.api.grpc.query.TransactionsRequest,
      bdledger.api.grpc.query.CountTransactionsResponse> getCountTransactionsMethod() {
    io.grpc.MethodDescriptor<bdledger.api.grpc.query.TransactionsRequest, bdledger.api.grpc.query.CountTransactionsResponse> getCountTransactionsMethod;
    if ((getCountTransactionsMethod = QueryGrpc.getCountTransactionsMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getCountTransactionsMethod = QueryGrpc.getCountTransactionsMethod) == null) {
          QueryGrpc.getCountTransactionsMethod = getCountTransactionsMethod =
              io.grpc.MethodDescriptor.<bdledger.api.grpc.query.TransactionsRequest, bdledger.api.grpc.query.CountTransactionsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "CountTransactions"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.TransactionsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.query.CountTransactionsResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("CountTransactions"))
              .build();
        }
      }
    }
    return getCountTransactionsMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static QueryStub newStub(io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<QueryStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<QueryStub>() {
        @java.lang.Override
        public QueryStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new QueryStub(channel, callOptions);
        }
      };
    return QueryStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static QueryBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<QueryBlockingStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<QueryBlockingStub>() {
        @java.lang.Override
        public QueryBlockingStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new QueryBlockingStub(channel, callOptions);
        }
      };
    return QueryBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static QueryFutureStub newFutureStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<QueryFutureStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<QueryFutureStub>() {
        @java.lang.Override
        public QueryFutureStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new QueryFutureStub(channel, callOptions);
        }
      };
    return QueryFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class QueryImplBase implements io.grpc.BindableService {

    /**
     */
    public void getBlockByHash(bdledger.api.grpc.query.GetBlockByHashRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetBlockByHashResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetBlockByHashMethod(), responseObserver);
    }

    /**
     */
    public void getBlocks(bdledger.api.grpc.query.BlocksRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetBlocksResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetBlocksMethod(), responseObserver);
    }

    /**
     */
    public void countBlocks(bdledger.api.grpc.query.BlocksRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.CountBlocksResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getCountBlocksMethod(), responseObserver);
    }

    /**
     */
    public void getTransactionByHash(bdledger.api.grpc.query.GetTransactionByHashRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetTransactionByHashResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetTransactionByHashMethod(), responseObserver);
    }

    /**
     */
    public void getTransactionByBlockHashAndIndex(bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetTransactionByBlockHashAndIndexMethod(), responseObserver);
    }

    /**
     */
    public void getTransactions(bdledger.api.grpc.query.TransactionsRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetTransactionsResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetTransactionsMethod(), responseObserver);
    }

    /**
     */
    public void countTransactions(bdledger.api.grpc.query.TransactionsRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.CountTransactionsResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getCountTransactionsMethod(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getGetBlockByHashMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdledger.api.grpc.query.GetBlockByHashRequest,
                bdledger.api.grpc.query.GetBlockByHashResponse>(
                  this, METHODID_GET_BLOCK_BY_HASH)))
          .addMethod(
            getGetBlocksMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdledger.api.grpc.query.BlocksRequest,
                bdledger.api.grpc.query.GetBlocksResponse>(
                  this, METHODID_GET_BLOCKS)))
          .addMethod(
            getCountBlocksMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdledger.api.grpc.query.BlocksRequest,
                bdledger.api.grpc.query.CountBlocksResponse>(
                  this, METHODID_COUNT_BLOCKS)))
          .addMethod(
            getGetTransactionByHashMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdledger.api.grpc.query.GetTransactionByHashRequest,
                bdledger.api.grpc.query.GetTransactionByHashResponse>(
                  this, METHODID_GET_TRANSACTION_BY_HASH)))
          .addMethod(
            getGetTransactionByBlockHashAndIndexMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexRequest,
                bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexResponse>(
                  this, METHODID_GET_TRANSACTION_BY_BLOCK_HASH_AND_INDEX)))
          .addMethod(
            getGetTransactionsMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdledger.api.grpc.query.TransactionsRequest,
                bdledger.api.grpc.query.GetTransactionsResponse>(
                  this, METHODID_GET_TRANSACTIONS)))
          .addMethod(
            getCountTransactionsMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdledger.api.grpc.query.TransactionsRequest,
                bdledger.api.grpc.query.CountTransactionsResponse>(
                  this, METHODID_COUNT_TRANSACTIONS)))
          .build();
    }
  }

  /**
   */
  public static final class QueryStub extends io.grpc.stub.AbstractAsyncStub<QueryStub> {
    private QueryStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected QueryStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new QueryStub(channel, callOptions);
    }

    /**
     */
    public void getBlockByHash(bdledger.api.grpc.query.GetBlockByHashRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetBlockByHashResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetBlockByHashMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getBlocks(bdledger.api.grpc.query.BlocksRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetBlocksResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetBlocksMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void countBlocks(bdledger.api.grpc.query.BlocksRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.CountBlocksResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getCountBlocksMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getTransactionByHash(bdledger.api.grpc.query.GetTransactionByHashRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetTransactionByHashResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetTransactionByHashMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getTransactionByBlockHashAndIndex(bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetTransactionByBlockHashAndIndexMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getTransactions(bdledger.api.grpc.query.TransactionsRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetTransactionsResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetTransactionsMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void countTransactions(bdledger.api.grpc.query.TransactionsRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.query.CountTransactionsResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getCountTransactionsMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   */
  public static final class QueryBlockingStub extends io.grpc.stub.AbstractBlockingStub<QueryBlockingStub> {
    private QueryBlockingStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected QueryBlockingStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new QueryBlockingStub(channel, callOptions);
    }

    /**
     */
    public bdledger.api.grpc.query.GetBlockByHashResponse getBlockByHash(bdledger.api.grpc.query.GetBlockByHashRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetBlockByHashMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdledger.api.grpc.query.GetBlocksResponse getBlocks(bdledger.api.grpc.query.BlocksRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetBlocksMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdledger.api.grpc.query.CountBlocksResponse countBlocks(bdledger.api.grpc.query.BlocksRequest request) {
      return blockingUnaryCall(
          getChannel(), getCountBlocksMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdledger.api.grpc.query.GetTransactionByHashResponse getTransactionByHash(bdledger.api.grpc.query.GetTransactionByHashRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetTransactionByHashMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexResponse getTransactionByBlockHashAndIndex(bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetTransactionByBlockHashAndIndexMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdledger.api.grpc.query.GetTransactionsResponse getTransactions(bdledger.api.grpc.query.TransactionsRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetTransactionsMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdledger.api.grpc.query.CountTransactionsResponse countTransactions(bdledger.api.grpc.query.TransactionsRequest request) {
      return blockingUnaryCall(
          getChannel(), getCountTransactionsMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class QueryFutureStub extends io.grpc.stub.AbstractFutureStub<QueryFutureStub> {
    private QueryFutureStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected QueryFutureStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new QueryFutureStub(channel, callOptions);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdledger.api.grpc.query.GetBlockByHashResponse> getBlockByHash(
        bdledger.api.grpc.query.GetBlockByHashRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetBlockByHashMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdledger.api.grpc.query.GetBlocksResponse> getBlocks(
        bdledger.api.grpc.query.BlocksRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetBlocksMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdledger.api.grpc.query.CountBlocksResponse> countBlocks(
        bdledger.api.grpc.query.BlocksRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getCountBlocksMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdledger.api.grpc.query.GetTransactionByHashResponse> getTransactionByHash(
        bdledger.api.grpc.query.GetTransactionByHashRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetTransactionByHashMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexResponse> getTransactionByBlockHashAndIndex(
        bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetTransactionByBlockHashAndIndexMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdledger.api.grpc.query.GetTransactionsResponse> getTransactions(
        bdledger.api.grpc.query.TransactionsRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetTransactionsMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdledger.api.grpc.query.CountTransactionsResponse> countTransactions(
        bdledger.api.grpc.query.TransactionsRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getCountTransactionsMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_GET_BLOCK_BY_HASH = 0;
  private static final int METHODID_GET_BLOCKS = 1;
  private static final int METHODID_COUNT_BLOCKS = 2;
  private static final int METHODID_GET_TRANSACTION_BY_HASH = 3;
  private static final int METHODID_GET_TRANSACTION_BY_BLOCK_HASH_AND_INDEX = 4;
  private static final int METHODID_GET_TRANSACTIONS = 5;
  private static final int METHODID_COUNT_TRANSACTIONS = 6;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final QueryImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(QueryImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_GET_BLOCK_BY_HASH:
          serviceImpl.getBlockByHash((bdledger.api.grpc.query.GetBlockByHashRequest) request,
              (io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetBlockByHashResponse>) responseObserver);
          break;
        case METHODID_GET_BLOCKS:
          serviceImpl.getBlocks((bdledger.api.grpc.query.BlocksRequest) request,
              (io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetBlocksResponse>) responseObserver);
          break;
        case METHODID_COUNT_BLOCKS:
          serviceImpl.countBlocks((bdledger.api.grpc.query.BlocksRequest) request,
              (io.grpc.stub.StreamObserver<bdledger.api.grpc.query.CountBlocksResponse>) responseObserver);
          break;
        case METHODID_GET_TRANSACTION_BY_HASH:
          serviceImpl.getTransactionByHash((bdledger.api.grpc.query.GetTransactionByHashRequest) request,
              (io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetTransactionByHashResponse>) responseObserver);
          break;
        case METHODID_GET_TRANSACTION_BY_BLOCK_HASH_AND_INDEX:
          serviceImpl.getTransactionByBlockHashAndIndex((bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexRequest) request,
              (io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetTransactionByBlockHashAndIndexResponse>) responseObserver);
          break;
        case METHODID_GET_TRANSACTIONS:
          serviceImpl.getTransactions((bdledger.api.grpc.query.TransactionsRequest) request,
              (io.grpc.stub.StreamObserver<bdledger.api.grpc.query.GetTransactionsResponse>) responseObserver);
          break;
        case METHODID_COUNT_TRANSACTIONS:
          serviceImpl.countTransactions((bdledger.api.grpc.query.TransactionsRequest) request,
              (io.grpc.stub.StreamObserver<bdledger.api.grpc.query.CountTransactionsResponse>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class QueryBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    QueryBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return bdledger.api.grpc.query.QueryProto.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("Query");
    }
  }

  private static final class QueryFileDescriptorSupplier
      extends QueryBaseDescriptorSupplier {
    QueryFileDescriptorSupplier() {}
  }

  private static final class QueryMethodDescriptorSupplier
      extends QueryBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    QueryMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (QueryGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new QueryFileDescriptorSupplier())
              .addMethod(getGetBlockByHashMethod())
              .addMethod(getGetBlocksMethod())
              .addMethod(getCountBlocksMethod())
              .addMethod(getGetTransactionByHashMethod())
              .addMethod(getGetTransactionByBlockHashAndIndexMethod())
              .addMethod(getGetTransactionsMethod())
              .addMethod(getCountTransactionsMethod())
              .build();
        }
      }
    }
    return result;
  }
}
