package bdledger.api.grpc.ledger;

import static io.grpc.MethodDescriptor.generateFullMethodName;
import static io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static io.grpc.stub.ClientCalls.asyncUnaryCall;
import static io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static io.grpc.stub.ClientCalls.blockingUnaryCall;
import static io.grpc.stub.ClientCalls.futureUnaryCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.27.0)",
    comments = "Source: bdledger/api/ledger.proto")
public final class LedgerGrpc {

  private LedgerGrpc() {}

  public static final String SERVICE_NAME = "bdledger.api.Ledger";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<bdledger.api.grpc.ledger.CreateLedgerRequest,
      bdledger.api.grpc.ledger.CreateLedgerResponse> getCreateLedgerMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "CreateLedger",
      requestType = bdledger.api.grpc.ledger.CreateLedgerRequest.class,
      responseType = bdledger.api.grpc.ledger.CreateLedgerResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdledger.api.grpc.ledger.CreateLedgerRequest,
      bdledger.api.grpc.ledger.CreateLedgerResponse> getCreateLedgerMethod() {
    io.grpc.MethodDescriptor<bdledger.api.grpc.ledger.CreateLedgerRequest, bdledger.api.grpc.ledger.CreateLedgerResponse> getCreateLedgerMethod;
    if ((getCreateLedgerMethod = LedgerGrpc.getCreateLedgerMethod) == null) {
      synchronized (LedgerGrpc.class) {
        if ((getCreateLedgerMethod = LedgerGrpc.getCreateLedgerMethod) == null) {
          LedgerGrpc.getCreateLedgerMethod = getCreateLedgerMethod =
              io.grpc.MethodDescriptor.<bdledger.api.grpc.ledger.CreateLedgerRequest, bdledger.api.grpc.ledger.CreateLedgerResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "CreateLedger"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.ledger.CreateLedgerRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.ledger.CreateLedgerResponse.getDefaultInstance()))
              .setSchemaDescriptor(new LedgerMethodDescriptorSupplier("CreateLedger"))
              .build();
        }
      }
    }
    return getCreateLedgerMethod;
  }

  private static volatile io.grpc.MethodDescriptor<com.google.protobuf.Empty,
      bdledger.api.grpc.ledger.GetLedgersResponse> getGetLedgersMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetLedgers",
      requestType = com.google.protobuf.Empty.class,
      responseType = bdledger.api.grpc.ledger.GetLedgersResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<com.google.protobuf.Empty,
      bdledger.api.grpc.ledger.GetLedgersResponse> getGetLedgersMethod() {
    io.grpc.MethodDescriptor<com.google.protobuf.Empty, bdledger.api.grpc.ledger.GetLedgersResponse> getGetLedgersMethod;
    if ((getGetLedgersMethod = LedgerGrpc.getGetLedgersMethod) == null) {
      synchronized (LedgerGrpc.class) {
        if ((getGetLedgersMethod = LedgerGrpc.getGetLedgersMethod) == null) {
          LedgerGrpc.getGetLedgersMethod = getGetLedgersMethod =
              io.grpc.MethodDescriptor.<com.google.protobuf.Empty, bdledger.api.grpc.ledger.GetLedgersResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetLedgers"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.protobuf.Empty.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.ledger.GetLedgersResponse.getDefaultInstance()))
              .setSchemaDescriptor(new LedgerMethodDescriptorSupplier("GetLedgers"))
              .build();
        }
      }
    }
    return getGetLedgersMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdledger.api.grpc.ledger.SendTransactionRequest,
      bdledger.api.grpc.ledger.SendTransactionResponse> getSendTransactionMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "SendTransaction",
      requestType = bdledger.api.grpc.ledger.SendTransactionRequest.class,
      responseType = bdledger.api.grpc.ledger.SendTransactionResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdledger.api.grpc.ledger.SendTransactionRequest,
      bdledger.api.grpc.ledger.SendTransactionResponse> getSendTransactionMethod() {
    io.grpc.MethodDescriptor<bdledger.api.grpc.ledger.SendTransactionRequest, bdledger.api.grpc.ledger.SendTransactionResponse> getSendTransactionMethod;
    if ((getSendTransactionMethod = LedgerGrpc.getSendTransactionMethod) == null) {
      synchronized (LedgerGrpc.class) {
        if ((getSendTransactionMethod = LedgerGrpc.getSendTransactionMethod) == null) {
          LedgerGrpc.getSendTransactionMethod = getSendTransactionMethod =
              io.grpc.MethodDescriptor.<bdledger.api.grpc.ledger.SendTransactionRequest, bdledger.api.grpc.ledger.SendTransactionResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "SendTransaction"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.ledger.SendTransactionRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdledger.api.grpc.ledger.SendTransactionResponse.getDefaultInstance()))
              .setSchemaDescriptor(new LedgerMethodDescriptorSupplier("SendTransaction"))
              .build();
        }
      }
    }
    return getSendTransactionMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static LedgerStub newStub(io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<LedgerStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<LedgerStub>() {
        @java.lang.Override
        public LedgerStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new LedgerStub(channel, callOptions);
        }
      };
    return LedgerStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static LedgerBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<LedgerBlockingStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<LedgerBlockingStub>() {
        @java.lang.Override
        public LedgerBlockingStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new LedgerBlockingStub(channel, callOptions);
        }
      };
    return LedgerBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static LedgerFutureStub newFutureStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<LedgerFutureStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<LedgerFutureStub>() {
        @java.lang.Override
        public LedgerFutureStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new LedgerFutureStub(channel, callOptions);
        }
      };
    return LedgerFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class LedgerImplBase implements io.grpc.BindableService {

    /**
     */
    public void createLedger(bdledger.api.grpc.ledger.CreateLedgerRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.ledger.CreateLedgerResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getCreateLedgerMethod(), responseObserver);
    }

    /**
     */
    public void getLedgers(com.google.protobuf.Empty request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.ledger.GetLedgersResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetLedgersMethod(), responseObserver);
    }

    /**
     */
    public void sendTransaction(bdledger.api.grpc.ledger.SendTransactionRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.ledger.SendTransactionResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getSendTransactionMethod(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getCreateLedgerMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdledger.api.grpc.ledger.CreateLedgerRequest,
                bdledger.api.grpc.ledger.CreateLedgerResponse>(
                  this, METHODID_CREATE_LEDGER)))
          .addMethod(
            getGetLedgersMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.protobuf.Empty,
                bdledger.api.grpc.ledger.GetLedgersResponse>(
                  this, METHODID_GET_LEDGERS)))
          .addMethod(
            getSendTransactionMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdledger.api.grpc.ledger.SendTransactionRequest,
                bdledger.api.grpc.ledger.SendTransactionResponse>(
                  this, METHODID_SEND_TRANSACTION)))
          .build();
    }
  }

  /**
   */
  public static final class LedgerStub extends io.grpc.stub.AbstractAsyncStub<LedgerStub> {
    private LedgerStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected LedgerStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new LedgerStub(channel, callOptions);
    }

    /**
     */
    public void createLedger(bdledger.api.grpc.ledger.CreateLedgerRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.ledger.CreateLedgerResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getCreateLedgerMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getLedgers(com.google.protobuf.Empty request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.ledger.GetLedgersResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetLedgersMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void sendTransaction(bdledger.api.grpc.ledger.SendTransactionRequest request,
        io.grpc.stub.StreamObserver<bdledger.api.grpc.ledger.SendTransactionResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getSendTransactionMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   */
  public static final class LedgerBlockingStub extends io.grpc.stub.AbstractBlockingStub<LedgerBlockingStub> {
    private LedgerBlockingStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected LedgerBlockingStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new LedgerBlockingStub(channel, callOptions);
    }

    /**
     */
    public bdledger.api.grpc.ledger.CreateLedgerResponse createLedger(bdledger.api.grpc.ledger.CreateLedgerRequest request) {
      return blockingUnaryCall(
          getChannel(), getCreateLedgerMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdledger.api.grpc.ledger.GetLedgersResponse getLedgers(com.google.protobuf.Empty request) {
      return blockingUnaryCall(
          getChannel(), getGetLedgersMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdledger.api.grpc.ledger.SendTransactionResponse sendTransaction(bdledger.api.grpc.ledger.SendTransactionRequest request) {
      return blockingUnaryCall(
          getChannel(), getSendTransactionMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class LedgerFutureStub extends io.grpc.stub.AbstractFutureStub<LedgerFutureStub> {
    private LedgerFutureStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected LedgerFutureStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new LedgerFutureStub(channel, callOptions);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdledger.api.grpc.ledger.CreateLedgerResponse> createLedger(
        bdledger.api.grpc.ledger.CreateLedgerRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getCreateLedgerMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdledger.api.grpc.ledger.GetLedgersResponse> getLedgers(
        com.google.protobuf.Empty request) {
      return futureUnaryCall(
          getChannel().newCall(getGetLedgersMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdledger.api.grpc.ledger.SendTransactionResponse> sendTransaction(
        bdledger.api.grpc.ledger.SendTransactionRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getSendTransactionMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_CREATE_LEDGER = 0;
  private static final int METHODID_GET_LEDGERS = 1;
  private static final int METHODID_SEND_TRANSACTION = 2;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final LedgerImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(LedgerImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_CREATE_LEDGER:
          serviceImpl.createLedger((bdledger.api.grpc.ledger.CreateLedgerRequest) request,
              (io.grpc.stub.StreamObserver<bdledger.api.grpc.ledger.CreateLedgerResponse>) responseObserver);
          break;
        case METHODID_GET_LEDGERS:
          serviceImpl.getLedgers((com.google.protobuf.Empty) request,
              (io.grpc.stub.StreamObserver<bdledger.api.grpc.ledger.GetLedgersResponse>) responseObserver);
          break;
        case METHODID_SEND_TRANSACTION:
          serviceImpl.sendTransaction((bdledger.api.grpc.ledger.SendTransactionRequest) request,
              (io.grpc.stub.StreamObserver<bdledger.api.grpc.ledger.SendTransactionResponse>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class LedgerBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    LedgerBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return bdledger.api.grpc.ledger.LedgerProto.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("Ledger");
    }
  }

  private static final class LedgerFileDescriptorSupplier
      extends LedgerBaseDescriptorSupplier {
    LedgerFileDescriptorSupplier() {}
  }

  private static final class LedgerMethodDescriptorSupplier
      extends LedgerBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    LedgerMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (LedgerGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new LedgerFileDescriptorSupplier())
              .addMethod(getCreateLedgerMethod())
              .addMethod(getGetLedgersMethod())
              .addMethod(getSendTransactionMethod())
              .build();
        }
      }
    }
    return result;
  }
}
